''**********************
''* Basic Sound Driver *
''*    For Beeps       *
''*         And Boops  *
''*(C)2007 Shayne Helms*
''**********************
CON
 LAUD = 17
 RAUD = 16
 
VAR
 long Cog
 long stack[9]
                           
PUB Start(Freq, Duration) : okay
''Start controller driver - starts a cog
''returns false if no cog available
 stop
  if cog
    cogstop(cog~ - 1)   
  okay := Cog := cognew(PlayFreq(Freq, Duration), @stack) + 1
  
PUB Stop
''Stop controller driver - frees a cog
 if cog
  cogstop(cog~ - 1)

PUB Active: YesNo
{{Return TRUE if process is active, FALSE otherwise.}}

 YesNo:= Cog > 0
  
PUB init
''Setup the proper pin directions
DIRA[LAUD]~~
DIRA[RAUD]~~

PUB PlayFreq (Freq, Duration)
''Play Freq on Left/Right pins for Duration cycles
init
repeat Duration
 !OUTA[RAUD]
 !OUTA[LAUD]  
 waitcnt(clkfreq * 1/Freq + cnt)
OUTA[LAUD]~
OUTA[RAUD]~
Cog~